Unit Sor_Int_Unit;					    {1992.04.17. SorUnit.pas}

Interface
  {
	       Integer elemekbl, folytonos abrazolasu ll sorok kezelse:
  }
  Const MaxHossz=100;
  Type  TElem=Integer;
        TSor =Record
                eleje,
                vege,
                hossz:Integer;
                se:Array [1..MaxHossz] of TElem;
                hiba:Boolean;
              End;

  Procedure Ures {legyen}(Var s:TSor);
  Function  UresE {?}(Const s:TSor):Boolean;
  Procedure Sorba(Var s:TSor; Const e:TElem);
  Function  Sorbol(Var s:TSor):TElem;
  Function  Elso(Var s:TSor):TElem; 
  Function  SorHossz(Const s:TSor):Integer;
  Function  TeleE {?}(Const s:TSor):Boolean;
  Function  HibasE {?}(Var s:TSor):Boolean;

Implementation

  Procedure cInc(Var x:Integer);
  Begin
    If x=MaxHossz then x:=1 else Inc(x);
  End;
  
  Procedure Ures {legyen}(Var s:TSor);
  Begin
    s.eleje:=1; s.vege:=1; s.hossz:=0; 
    s.hiba:=False;
  End;

  Function  UresE {?}(Const s:TSor):Boolean;
  Begin
    UresE:=s.hossz=0;
  End;

  Procedure Sorba(Var s:TSor; Const e:TElem);
  Begin
    If not TeleE(s) then
    Begin
      s.se[s.vege]:=e; cInc(s.vege); Inc(s.hossz);
    End
	    else
    Begin
      s.hiba:=True;
    End
  End;

  Function  Sorbol(Var s:TSor):TElem;
  Begin
    If not UresE(s) then
    Begin
      Sorbol:=s.se[s.eleje]; cInc(s.eleje); Dec(s.hossz);
    End
	    else
    Begin
      s.hiba:=True;
    End
  End;

  Function  Elso(Var s:TSor):TElem; 
  Begin
    If not UresE(s) then
    Begin
      Elso:=s.se[s.eleje];
    End
      else
    Begin
      s.hiba:=True;
    End;
  End;
  
  Function  SorHossz(Const s:TSor):Integer;
  Begin
    SorHossz:=s.hossz;
  End;

  Function  TeleE {?}(Const s:TSor):Boolean;
  Begin
    TeleE:=s.hossz=MaxHossz;
  End;
  
  Function HibasE(Var s:TSor):Boolean;
  Begin
    HibasE:=s.hiba; s.hiba:=False;
  End;

Begin
End.
